<?php

declare(strict_types=1);

namespace Dedi\SyliusClicAndPayPlugin\Payum\Action;

use Dedi\SyliusClicAndPayPlugin\Payum\ClicAndPayParams;
use Payum\Core\Action\ActionInterface;
use Payum\Core\Request\Generic;
use Payum\Core\Request\GetStatusInterface;
use Sylius\Component\Core\Model\PaymentInterface;

class StatusAction implements ActionInterface
{
    public function execute($request)
    {
        /** @var PaymentInterface $payment */
        $payment = $request->getFirstModel();
        $details = $payment->getDetails();

        if (null === $details['status']) {
            $request->markNew();
        } elseif ($details['status'] === ClicAndPayParams::AUTHORISED_STATUS) {
            $request->markCaptured();
        } elseif ($details['status'] === ClicAndPayParams::ABANDONED_STATUS) {
            $request->markCanceled();
        } else {
            $request->markFailed();
        }
    }

    /**
     * @param Generic $request
     *
     * @return bool
     */
    public function supports($request)
    {
        return
            $request instanceof GetStatusInterface &&
            $request->getFirstModel() instanceof PaymentInterface
        ;
    }
}
