<?php

declare(strict_types=1);

namespace Dedi\SyliusClicAndPayPlugin\Payum;

interface ClicAndPayParams
{
    const SERVERS = ['clicandpay.groupecdn.fr'];

    const URL_CLASSIC = 'vads-payment/';
    const DEVISE_EURO = '978';
    const VERSION = 'V2';
    const HASH = 'sha256';
    const IS_MULTI_PAYMENT = 'is_multi_payment';
    const MULTI_PAYMENT_FIRST_PERCENT = 'multi_payment_first_percent';
    const MULTI_PAYMENT_COUNT = 'multi_payment_count';
    const MULTI_PAYMENT_PERIOD = 'multi_payment_period';
    const AUTHORISED_STATUS = 'AUTHORISED';
    const ABANDONED_STATUS = 'ABANDONED';
    const REFUSED_STATUS = 'REFUSED';
    const AUTHORISED_TO_VALIDATE_STATUS = 'AUTHORISED_TO_VALIDATE';
    const WAITING_AUTHORISATION_STATUS = 'WAITING_AUTHORISATION';
    const WAITING_AUTHORISATION_TO_VALIDATE_STATUS = 'WAITING_AUTHORISATION_TO_VALIDATE';

    const SIGNATURE = 'signature';
    const VADS_ACTION_MODE = 'vads_action_mode';
    const VADS_AMOUT = 'vads_amount';
    const VADS_CTX_MODE = 'vads_ctx_mode';
    const VADS_CURRENCY = 'vads_currency';
    const VADS_PAGE_ACTION = 'vads_page_action';
    const VADS_PAYMENT_CONFIG = 'vads_payment_config';
    const VADS_SITE_ID = 'vads_site_id';
    const VADS_SITE_KEY = 'vads_site_key';
    const VADS_TRANS_DATE = 'vads_trans_date';
    const VADS_TRANS_ID = 'vads_trans_id';
    const VADS_VERSION = 'vads_version';

    const VADS_RETURN_MODE = 'vads_return_mode';
    const VADS_URL_RETURN = 'vads_url_return';

    const VADS_TRANS_STATUS = 'vads_trans_status';

    const VADS_ORDER_TO_SIGNATURE = [
        self::VADS_ACTION_MODE,
        self::VADS_AMOUT,
        self::VADS_CTX_MODE,
        self::VADS_CURRENCY,
        self::VADS_PAGE_ACTION,
        self::VADS_PAYMENT_CONFIG,
        self::VADS_RETURN_MODE,
        self::VADS_SITE_ID,
        self::VADS_TRANS_DATE,
        self::VADS_TRANS_ID,
        self::VADS_URL_RETURN,
        self::VADS_VERSION,
    ];
}
